//+------------------------------------------------------------------+
//|                                                   Thrust_Bar.mq4 |
//|                               Copyright  2014, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red

extern int ATR_Length=14;
extern bool Use_ATR=true; // true - ATR
                          // false - pips
extern double Multiplier=2;
extern bool Long_Side=true;
extern bool Short_Side=true; 
extern int Label_Size=3;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

double UP[], DN[];

int init()
{
 IndicatorShortName("Thrust Bar");
 IndicatorDigits(Digits);
 SetIndexStyle(0,DRAW_ARROW,0,Label_Size);
 SetIndexArrow(0,119);
 SetIndexBuffer(0,UP);
 SetIndexStyle(1,DRAW_ARROW,0,Label_Size);
 SetIndexArrow(1,119);
 SetIndexBuffer(1,DN);

 return(0);
}

int deinit()
{

 return(0);
}

int start()
{
 if(Bars<=3) return(0);
 int ExtCountedBars=IndicatorCounted();
 if (ExtCountedBars<0) return(-1);
 int limit=Bars-2;
 if(ExtCountedBars>2) limit=Bars-ExtCountedBars-1;
 int pos;
 double X, Y;
 pos=Bars-1;
 while(pos>=0)
 {
   UP[pos] = EMPTY_VALUE;
   DN[pos] = EMPTY_VALUE;
  if (Use_ATR)
  {
   X=Multiplier*iATR(NULL, 0, ATR_Length, pos)/Point;
  }
  else
  {
   X=Multiplier;
  }
  Y=(Close[pos]-Open[pos])/Point;
  if (Y>X && Long_Side)
  {
   UP[pos]=Low[pos];
  }
  if (Y<-X && Short_Side)
  {
   DN[pos]=High[pos];
  }

  pos--;
 } 
   if (alertsOn)
   {   
      int testbar = 1; if (alertsOnCurrent) testbar = 0;
         if (UP[testbar]!=EMPTY_VALUE) doAlert(0," thrust bar up");
         if (DN[testbar]!=EMPTY_VALUE) doAlert(0," thrust bar down");
   }         
 
 return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" new "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+"Thrust bar",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}